unit Unit1;
 {$define DEBUG}

{ This unit demonstrates the three ways to use the DebugDlg
  component. You need to install the component from
  DJMDebug.pas into your Delphi palette before you'll be able
  to compile this unit; if you don't want to do that, then
  just remove this unit from the project to compile it.

  The first button leads to a call to the SnapShot
  method, which reports on the current state.

  The second button leads to a call to the Exception method,
  which reports on the state from an except clause.

  For both of these, a stack trace is shown at the time of
  the call.

  The last button triggers an unhandled exception; this is
  reported by a second DebugDlg component, which is set to
  do a stack dump instead, to show the whole string of routines
  between the place the exception was triggered, and where it was
  finally handled by the default handler.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,DJMDebug;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    DebugDlg1: TDebugDlg;
    DebugDlg2: TDebugDlg;
    Runerror: TButton;

    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure RunerrorClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2,dbugintf;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
  procedure Nested(var arg:TForm1); stdcall;
    procedure Nested2;
    begin
      DebugDlg1.Snapshot('Deeply nested');
      {$IFDEF DEBUG}
      SendDebugEx('',mtInformation);
      {$ENDIF}
    end;
  begin
    Nested2;
  end;
begin
  Nested(form1);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  x,y : integer;
begin
  try
    x := 0;
    y := 0;
    x := x div y;
    showmessage(IntToStr(x));
  except
    on Exception do
      DebugDlg1.ShowException;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
procedure Nested;
procedure Nested2;
var
  x,y : integer;
begin
  x := 0;
  y := 0;
  x := x div y;
  showmessage(IntToStr(x));
end;
begin
  Nested2;
end;
begin
  Nested;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.RunerrorClick(Sender: TObject);
begin
  System.Runerror(99);
end;

end.
